//
//  ListaEstatisticas.swift
//  TrabalhoPraticoLP
//
//  Created by Sandor ferreira da silva on 24/11/18.
//  Copyright © 2018 Sandor Ferreira da Silva. All rights reserved.
//

import Foundation

class ListaEstatisticas {
    
    init() {}
    
    var dataToShow = [[String]]()
    
    public func createListaEstatisticas(listaQualis: [Qualis], publicacoes: [Publicacao]) -> [[String]] {
        let nomeQualis = ["A1", "A2", "B1", "B2", "B3", "B4", "B5", "C"]
        var data = [String]()
        
        for qualis in nomeQualis {
            var artigos = 0
            var artigosPorDocente = 0.0
            for publicacao in publicacoes {
                if publicacao.getQualis(listaQualis: listaQualis) == qualis {
                    artigos += 1
                    if (publicacao.getAutores().count != 0) {
                        artigosPorDocente += 1.0/Double(publicacao.getAutores().count)
                    }
                    //print(artigosPorDocente)
                }
            }
            let string = "\(qualis);\(artigos);\(artigosPorDocente)\n"
            let content = ["\(qualis)","\(artigos)","\(artigosPorDocente)"]
            
            //print(string)
            dataToShow.append(content)
            data.append(string)
        }
        createCSVFile(from: data)
        return self.dataToShow
        
    }
    
    private func createCSVFile(from data: [String]) {
        
        let fileManager = FileManager.default
        
        do {
            let path = try fileManager.url(for: .documentDirectory, in: .allDomainsMask, appropriateFor: nil, create: false)
            let fileURL = path.appendingPathComponent("estatisticas.csv")
            for content in data {
                //print("heeey???")
                try content.write(to: fileURL, atomically: true, encoding: .utf8)
            }
        } catch {
            print("error while trying to create CSV File")
            print(error.localizedDescription)
        }
    }
}
