//
//  Docente.swift
//  TrabalhoPraticoLP
//
//  Created by Sandor ferreira da silva on 08/11/18.
//  Copyright © 2018 Sandor Ferreira da Silva. All rights reserved.
//

import Foundation
class Docente: Comparable {
    private let codigo: String
    private let nome: String
    private let dataDeNascimento: String
    private let dataDeIngresso: String
    private let coordenador: Bool
    
    init(codigo: String, nome: String, dataDeNascimento: String, dataDeIngresso: String, coordenador: Bool) {
        self.codigo = codigo
        self.nome = nome
        self.dataDeNascimento = dataDeNascimento
        self.dataDeIngresso = dataDeIngresso
        self.coordenador = coordenador
    }
    
    public var Nome : String {
        return self.nome
    }
    
    public var DataDeNascimento : String {
        return self.dataDeNascimento
    }
    
    public var DataDeIngresso : String {
        return self.dataDeIngresso
    }
    
    public var isCoordenador : Bool {
        return self.coordenador
    }
    
    public var dCodigo : String {
        return codigo
    }
    
    public func getPublicacoes(publicacoes: [Publicacao]) -> [Publicacao] {
        var auxPublicacoes = [Publicacao]()
        for publicacao in publicacoes {
            let autores = publicacao.getAutores()
            for autor in autores {
                if self.codigo == autor.codigo {
                    auxPublicacoes.append(publicacao)
                }
            }
        }
        return auxPublicacoes
    }
    
    static func ==(lhs: Docente, rhs: Docente) -> Bool {
        return lhs.nome == rhs.nome
    }
    
    static func <(lhs: Docente, rhs: Docente) -> Bool {
        return lhs.nome < rhs.nome
    }
}
