//
//  Publicacao.swift
//  TrabalhoPraticoLP
//
//  Created by Sandor ferreira da silva on 23/11/18.
//  Copyright © 2018 Sandor Ferreira da Silva. All rights reserved.
//

import Foundation
class Publicacao {
    private let titulo: String
    private var listaAutores = [Docente]()
    private let ano: Int
    private let pagInicial, pagFinal : Int
    private let numero: Int?
    private let volume: Int?
    private let local: String?
    private let veiculo: Veiculo
    
    public init(titulo: String, ano: Int, pagInicial: Int, pagFinal: Int, numero: Int?, volume: Int?, local: String?, veiculo: Veiculo) {
    self.numero = numero
    self.volume = volume
    self.local = local
    self.titulo = titulo
    self.ano = ano
    self.pagFinal = pagFinal
    self.pagInicial = pagInicial
    self.veiculo = veiculo
    }
    
    public func setAutores(codigos: [String], docentes: [Docente]) {
        for codigo in codigos {
            for docente in docentes {
                if codigo == docente.dCodigo {
                    self.listaAutores.append(docente)
                }
            }
        }
    }
    
    public func periodico() -> Bool {
        if self.volume != nil {
            return true
        } else {
            return false
        }
    }
    
    public func getAutores() -> [Docente] {
        return self.listaAutores
    }
    
    public func getTitulo() -> String {
        return self.titulo
    }
    
    public func getVeiculo() -> Veiculo {
        return self.veiculo
    }
    
    public func getQualis(listaQualis: [Qualis]) -> String {
        return self.veiculo.getQualisName(listaQualis: listaQualis)
    }
    
    public func getAno() -> Int {
        return self.ano
    }
}
