//
//  Regra.swift
//  TrabalhoPraticoLP
//
//  Created by Sandor ferreira da silva on 23/11/18.
//  Copyright © 2018 Sandor Ferreira da Silva. All rights reserved.
//

import Foundation
class Regra {
    private let qualisStrings = ["A1", "A2", "B1", "B2", "B3", "B4", "B5", "C"]
    private var qualis: [String: Int]?
    private let dataInicio: String
    private let dataFim: String
    private let multiplicador: Double
    private let qtdAnos: Int
    private let minimoRecredenciamento: Double
    
    public init(dataInicio: String, dataFim: String, multiplicador: Double, qtdAnos: Int, minimoRecredenciamento: Double) {
        self.dataFim = dataFim
        self.dataInicio = dataInicio
        self.multiplicador = multiplicador
        self.qtdAnos = qtdAnos
        self.minimoRecredenciamento = minimoRecredenciamento
        
    }
    
    public func getMultiplicador() -> Double {
        return self.multiplicador
    }
    
    public func getMinimo() -> Double {
        return self.minimoRecredenciamento
    }
    public func recredenciado(pontos: Double) -> Bool {
        if pontos >= minimoRecredenciamento {
            return true
        } else {
            return false
        }
    }
    
    public func setQualisPontos(pontosString: String, quaStrings: String) {
        
        let stringPontos = pontosString.components(separatedBy: ",")
        var pontos = [Int]()
        for ponto in stringPontos {
            pontos.append(Int(ponto)!)
        }
        
        var auxpontos = [Int]()
        var j = 1
        let qStrings = quaStrings.components(separatedBy: ",")
        //print(qStrings)
        for q in qualisStrings {
            if q != qStrings[j] {
                auxpontos.append(pontos[j-1])
            } else {
                auxpontos.append(pontos[j])
                j = j + 1
            }
        }
        self.qualis = ["A1" : auxpontos[0],
                    "A2" : auxpontos[1],
                    "B1" : auxpontos[2],
                    "B2" : auxpontos[3],
                    "B3" : auxpontos[4],
                    "B4" : auxpontos[5],
                    "B5" : auxpontos[6],
                    "C" : auxpontos[7]]
    }
    
    public func getAno() -> String {
        return self.dataInicio.components(separatedBy: "/").last!
    }
    
    public func getQtdAnos() -> Int {
        return self.qtdAnos
    }
    
    public func getPontuacaoQualis(qualisName: String) -> Int {
        return self.qualis![qualisName]!
    }
}
